searchNodes=[{"doc":"This is the main Exsm module. It keeps most of the Exsm logics, it&#39;s the module that will be imported with use on the module responsible for the state machine. Declare the states as an argument when importing Exsm on the module that will control your states transitions. Exsm expects a Keyword as argument with two keys states and transitions. Parameters opts: A Keyword including states and transitions. states: A List of Strings representing each state. transitions: A Map for each state and it allowed next state(s). Example defmodule YourProject.UserStateMachine do use Exsm, # The first state declared will be considered # the intial state states: [&quot;created&quot;, &quot;partial&quot;, &quot;complete&quot;], transitions: %{ &quot;created&quot; =&gt; [&quot;partial&quot;, &quot;complete&quot;], &quot;partial&quot; =&gt; &quot;completed&quot; } end","ref":"Exsm.html","title":"Exsm","type":"module"},{"doc":"Main macro function that will be executed upon the load of the module using it. It basically stores the states and transitions. It expects a Keyword as argument with two keys states and transitions. states: A List of Strings representing each state. transitions: A Map for each state and it allowed next state(s). P.S. The first state declared will be considered the intial state","ref":"Exsm.html#__using__/1","title":"Exsm.__using__/1","type":"macro"},{"doc":"Triggers the transition of a struct to a new state, accordinly to a specific state machine module, if it passes any existing guard functions. It also runs any before or after callbacks and returns a tuple with {:ok, struct}, or {:error, &quot;reason&quot;}. Parameters struct: The struct you want to transit to another state. state_machine_module: The module that holds the state machine logic, where Exsm as imported. next_state: String of the next state you want to transition to. Examples iex&gt; Exsm.transition_to(%User{state: :partial}, UserStateMachine, :completed) {:ok, %User{state: :completed}}","ref":"Exsm.html#transition_to/3","title":"Exsm.transition_to/3","type":"function"},{"doc":"Returns true if transition is valid. Parameters struct: The struct you want to transit to another state. state_machine_module: The module that holds the state machine logic, where Exsm as imported. next_state: String of the next state you want to transition to. Examples iex&gt; Exsm.valid_transition?(%User{state: :partial}, UserStateMachine, :completed) true","ref":"Exsm.html#valid_transition?/3","title":"Exsm.valid_transition?/3","type":"function"},{"doc":"Exsm module responsible for control transitions, guard functions and callbacks (before and after). This is meant to be for internal use only.","ref":"Exsm.Transition.html","title":"Exsm.Transition","type":"module"},{"doc":"Function responsible to run all after_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Exsm.Transition.html#after_callbacks/4","title":"Exsm.Transition.after_callbacks/4","type":"function"},{"doc":"Function responsible to run all before_transitions callbacks or fallback to a boilerplate behaviour. This is meant to be for internal use only.","ref":"Exsm.Transition.html#before_callbacks/4","title":"Exsm.Transition.before_callbacks/4","type":"function"},{"doc":"Function responsible for checking if the transition from a state to another was specifically declared. This is meant to be for internal use only.","ref":"Exsm.Transition.html#declared_transition?/3","title":"Exsm.Transition.declared_transition?/3","type":"function"},{"doc":"Function resposible for triggering transitions persistence. This is meant to be for internal use only.","ref":"Exsm.Transition.html#log_transition/4","title":"Exsm.Transition.log_transition/4","type":"function"},{"doc":"This function will try to trigger persistence, if declared, to the struct changing state. This is meant to be for internal use only.","ref":"Exsm.Transition.html#persist_struct/4","title":"Exsm.Transition.persist_struct/4","type":"function"},{"doc":"This is a GenServer that controls the transitions for a struct using a set of helper functions from Exsm.Transition It&#39;s meant to be run by a supervisor.","ref":"Exsm.Transitions.html","title":"Exsm.Transitions","type":"module"},{"doc":"","ref":"Exsm.Transitions.html#parse_transitions/2","title":"Exsm.Transitions.parse_transitions/2","type":"function"},{"doc":"Exsm Exsm is a thin State Machine library for Elixir that integrates with Phoenix out of the box. It&#39;s just a small layer that provides a DSL for declaring states and having callbacks for structs. Don&#39;t forget to check the Exsm Docs Installation Declaring States State Machine Module Supported Declaration Types Wildcards Changing States Validate Transition Callbacks Before Callback Persist State Logging Transitions After Callback Credits","ref":"readme.html","title":"Exsm","type":"extras"},{"doc":"The package can be installed by adding exsm to your list of dependencies in mix.exs: def deps do [ {:exsm, &quot;~&gt; 0.3.0&quot;} ] end Create a field state (or a name of your choice to be defined later) for the module you want to have a state machine, make sure you have declared it as part of you defstruct, or if it is a Phoenix model make sure you add it to the schema, as a string, and to the changeset/2: defmodule YourProject.User do schema &quot;users&quot; do # ... field :state, :string # ... end def changeset(%User{} = user, attrs) do #... |&gt; cast(attrs, [:state]) #... end end","ref":"readme.html#installation","title":"Exsm - Installation","type":"extras"},{"doc":"Declare the states as an argument when importing Exsm on the module that will control your states transitions. State Machine Module It&#39;s strongly recommended that you create a new module for your State Machine logic. So let&#39;s say you want to add it to your User model, you should create a UserStateMachine module to hold your State Machine logic. Exsm expects a Keyword as argument with the keys field, states and transitions. field: An atom of your state field name (defaults to state) states: A List of Strings representing each state. transitions: A Map for each state and it allowed next state(s). Example defmodule YourProject.UserStateMachine do use Exsm, # This is a way to define a custom field, if not defined # it will expect the default `state` field in the struct field: :custom_state_name, # The first state declared will be considered # the initial state. states: [&quot;created&quot;, &quot;partial&quot;, &quot;complete&quot;, &quot;canceled&quot;], transitions: %{ &quot;created&quot; =&gt; [&quot;partial&quot;, &quot;complete&quot;], &quot;partial&quot; =&gt; &quot;completed&quot;, &quot;*&quot; =&gt; &quot;canceled&quot; } end Supported Declaration Types One - One Define transition from one state to another state. &quot;a&quot; =&gt; &quot;b&quot; One - Many Define transition from one state to multiple states. &quot;a&quot; =&gt; [&quot;b&quot;, &quot;c&quot;] Many - One Define transition from Multiple states to a single state. [&quot;a&quot;, &quot;b&quot;] =&gt; &quot;c&quot; Many - Many Define transition from multiple states to multiple other states. # This is equivalent to &quot;a&quot; =&gt; [&quot;c&quot;, &quot;d&quot;, &quot;e&quot;] and &quot;b&quot; =&gt; [&quot;c&quot;, &quot;d&quot;, &quot;e&quot;] [&quot;a&quot;, &quot;b&quot;] =&gt; [&quot;c&quot;, &quot;d&quot;, &quot;e&quot;] Wildcards The wildcards can be used to easily define transition from/to all defined states to a set of states. &quot;*&quot;: This wildcard can be used when you want to define a transtition from all defined states to a state or a subset including all self transitions. &quot;^&quot;: It serves a similar purpose as &quot;*&quot; but excludes all self transitions. Example states: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;], transitions: %{ &quot;*&quot; =&gt; &quot;b&quot;, # [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;] =&gt; &quot;b&quot; [&quot;a&quot;, &quot;b&quot;] =&gt; &quot;*&quot;, # [&quot;a&quot;, &quot;b&quot;] =&gt; [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;] &quot;^&quot; =&gt; [&quot;c&quot;, &quot;d&quot;], # [&quot;a&quot;, &quot;b&quot;, &quot;d&quot;, &quot;e&quot;] =&gt; &quot;c&quot; and [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;e&quot;] =&gt; &quot;d&quot; &quot;e&quot; =&gt; &quot;^&quot; # &quot;e&quot; =&gt; [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;] }","ref":"readme.html#declaring-states","title":"Exsm - Declaring States","type":"extras"},{"doc":"To transit a struct into another state, you just need to call Exsm.transition_to/3. Exsm.transition_to/3 It takes three arguments: struct: The struct you want to transit to another state. state_machine_module: The module that holds the state machine logic, where Exsm as imported. next_event: string of the next state you want the struct to transition to. Before and after callbacks will be checked automatically. Exsm.transition_to(your_struct, YourStateMachine, &quot;next_state&quot;) # {:ok, updated_struct} Example: user = Accounts.get_user!(1) Exsm.transition_to(user, UserStateMachine, &quot;complete&quot;)","ref":"readme.html#changing-states","title":"Exsm - Changing States","type":"extras"},{"doc":"If you want to check if a transition is valid without actually performing the transition, you can do so using Exsm.valid_transition?/3 Exsm.valid_transition?/3 It takes three arguments: struct: The struct you want to transit to another state. state_machine_module: The module that holds the state machine logic, where Exsm as imported. next_event: string of the next state you want the struct to transition to. Exsm.valid_transition?(your_struct, YourStateMachine, &quot;next_state&quot;) # true/false Example: user = Accounts.get_user!(1) Exsm.valid_transition?(user, UserStateMachine, &quot;complete&quot;)","ref":"readme.html#validate-transition","title":"Exsm - Validate Transition","type":"extras"},{"doc":"Callbacks are useful for defining side effectd during state transitions. Additionally before_transition/3 can be used as a guard to stop the transition from occuring if a certain pre-condition or a side effect fails. Callbacks are executed in the following order during a transition before_transition/3 persist/3 log_transition/3 after_transition/3 Before callback Before callback is useful for executing some side effects before the transition occurs as well as guarding the transition from happening either due to some pre-defined condition or side effect failing. Struct can also be modified here and the updated struct will be passed on to the other callbacks. Create before callback by adding signatures of the before_transition/3 function, it will receive three arguments, the struct, a prev_state from where the transition started and a next_state where it will transit to. Use the second and the third arguments to pattern match the previous and next states. before_transition/3 should return one of the following values: {:error, &quot;cause&quot;}: Transition won&#39;t be allowed in this case. {:ok, struct}: Transition will be allowed and the struct will be passed on to other callbacks Example: defmodule YourProject.UserStateMachine do use Exsm, states: [&quot;created&quot;, &quot;complete&quot;], transitions: %{&quot;created&quot; =&gt; &quot;complete&quot;} # Before callback for transition &quot;created&quot; to &quot;complete&quot; def before_transition(struct, &quot;created&quot;, &quot;complete&quot;) do if Map.get(struct, :missing_fields) == true do {:error, &quot;There are missing fields&quot;} else struct = preform_operation(struct) {:ok, struct} end end end When trying to transition an struct that is blocked by its before callback you will have the following return: blocked_struct = %TestStruct{state: &quot;created&quot;, missing_fields: true} Exsm.transition_to(blocked_struct, TestStateMachineWithGuard, &quot;completed&quot;) # {:error, &quot;There are missing fields&quot;} Persist State To persist the struct and the state transition automatically, instead of having Exsm changing the struct itself, you can declare a persist/3 function on the state machine module. It will receive the unchanged struct as the first argument, the prev_state as second and the next_state as the third one, after every state transition. That will be called between the before and after transition callbacks. persist/3 should always return the updated struct. Example: defmodule YourProject.UserStateMachine do alias YourProject.Accounts use Exsm, states: [&quot;created&quot;, &quot;complete&quot;], transitions: %{&quot;created&quot; =&gt; &quot;complete&quot;} def persist(struct, _prev_state, next_state) do # Updating a user on the database with the new state. {:ok, user} = Accounts.update_user(struct, %{state: next_state}) user end end Logging Transitions To log/persist the transitions itself Exsm provides a callback log_transitions/3 that will be called on every transition. It will receive the unchanged struct as the first argument, the prev_state as second and the next state as the third one, after every state transition. This function will be called between the before and after transition callbacks and after the persist function. log_transition/3 should always return the updated struct. Example: defmodule YourProject.UserStateMachine do alias YourProject.Accounts use Exsm, states: [&quot;created&quot;, &quot;complete&quot;], transitions: %{&quot;created&quot; =&gt; &quot;complete&quot;} def log_transition(struct, _prev_state, _next_state) do # Log transition here, save on the DB or whatever. # ... # Return the struct. struct end end After callback You can also use after callback to handle desired side effects and reactions to a specific state transition. You can just declare after_transition/3, pattern matching the desired state you want to. Make sure After callbacks should return the struct. # callbacks should always return the struct. def after_transition(struct, &quot;prev_state&quot;, &quot;next_state&quot;), do: struct Example: defmodule YourProject.UserStateMachine do use Exsm, states: [&quot;created&quot;, &quot;partial&quot;, &quot;complete&quot;], transitions: %{ &quot;created&quot; =&gt; [&quot;partial&quot;, &quot;complete&quot;], &quot;partial&quot; =&gt; &quot;completed&quot; } def after_transition(struct, _prev_state, &quot;completed&quot;) do # ... overall desired side effects struct end end","ref":"readme.html#callbacks","title":"Exsm - Callbacks","type":"extras"},{"doc":"Machinery - State machine thin layer for structs","ref":"readme.html#credits","title":"Exsm - Credits","type":"extras"}]